/* File: "bq26150.h" */

/************************************************************
* STANDARD BITS
************************************************************/
#define BIT0 (0x0001)
#define BIT1 (0x0002)
#define BIT2 (0x0004)
#define BIT3 (0x0008)
#define BIT4 (0x0010)
#define BIT5 (0x0020)
#define BIT6 (0x0040)
#define BIT7 (0x0080)
#define BIT8 (0x0100)
#define BIT9 (0x0200)
#define BITA (0x0400)
#define BITB (0x0800)
#define BITC (0x1000)
#define BITD (0x2000)
#define BITE (0x4000)
#define BITF (0x8000)

#define BQ26150CRYPTOKEYBYTE 0xFF

#define DEVICEKEYNUMBYTES 12
#define RANDOMCHALLENGENUMBYTES 4
#define POLYCOEFFNUMBYTES 2
#define POLYSEEDNUMBYTES 2
#define CRCNUMBYTES 2

#define EDS_HB 0x4F
#define EDS_LB 0x4E
#define EDP_HB 0x4D
#define EDP_LB 0x4C
#define EDK_11 0x4B
#define EDK_10 0x4A
#define EDK_09 0x49
#define EDK_08 0x48
#define EDK_07 0x47
#define EDK_06 0x46
#define EDK_05 0x45
#define EDK_04 0x44
#define EDK_03 0x43
#define EDK_02 0x42
#define EDK_01 0x41
#define EDK_00 0x40

#define CTRL  0x18
#define AUTH  BIT0
#define DONE  BIT1
#define POR   BIT2
#define OPASS BIT6
#define CPASS BIT7

#define CRC_HB 0x05
#define CRC_LB 0x04

#define RC_03 0x03
#define RC_02 0x02
#define RC_01 0x01
#define RC_00 0x00
